﻿using Infragistics.Win.UltraWinDataSource;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace UltraGridVirtualMode
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
       

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraGrid1.DataSource = this.ultraDataSource1;

            // Set the root band key so we can easily refer to it later in various 
            // event handlers. 

            this.ultraDataSource1.Band.Key = "Band 0";

            // Add three columns to the root band. 
            this.ultraDataSource1.Band.Columns.Add("ID", typeof(int));
            this.ultraDataSource1.Band.Columns.Add("Col0", typeof(int));
            this.ultraDataSource1.Band.Columns.Add("Col1", typeof(double));
            

            // Set the count on the root rows collection to 100. 
            this.ultraDataSource1.Rows.SetCount(100);

            // Set the id on the root rows. 
            UltraDataColumn column = this.ultraDataSource1.Band.Columns["ID"];
            for (int i = 0; i < this.ultraDataSource1.Rows.Count; i++)
                this.ultraDataSource1.Rows[i][column] = i;

            this.ultraGrid1.DisplayLayout.Bands[0].Columns["Col1"].CellAppearance.TextHAlign = Infragistics.Win.HAlign.Right;
            this.ultraGrid1.DisplayLayout.Bands[0].Columns["Col1"].Format = "#,##0.00;(#,##0.00)";

        }


        Random random = new Random();
        private void ultraDataSource1_CellDataRequested(object sender, Infragistics.Win.UltraWinDataSource.CellDataRequestedEventArgs e)
        {
            // CellDataRequested is fired for every cell. 
            // e.Row property indicates which row and e.Column indicates which column the 
            // cell data is being requested for. 
            UltraDataRow row = e.Row;

            if ("Band 0" == e.Column.Band.Key)
            {
                switch (e.Column.Key)
                {
                    case "Col0":
                        e.Data = this.random.Next();
                        break;
                    case "Col1":
                        e.Data = this.random.NextDouble();
                        break;
                }
            }          

            // If CacheData is set to true, which it is by default, then UltraDataSource 
            // will cache the provided cell value and won't fire CellDataRequested next 
            // time for the cell. 
            e.CacheData = true;
        }       
    }
}
